HDU-3631-floyd插点法

Shortest Path

                                                   Time Limit: 3000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
                                                   Total Submission(s): 5285    Accepted Submission(s): 1274


Problem Description
When YY was a boy and LMY was a girl, they trained for NOI (National Olympiad in Informatics) in GD team. One day, GD team’s coach, Prof. GUO asked them to solve the following shortest-path problem.
There is a weighted directed multigraph G. And there are following two operations for the weighted directed multigraph:
(1) Mark a vertex in the graph.
(2) Find the shortest-path between two vertices only through marked vertices.
For it was the first time that LMY faced such a problem, she was very nervous. At this moment, YY decided to help LMY to analyze the shortest-path problem. With the help of YY, LMY solved the problem at once, admiring YY very much. Since then, when LMY meets problems, she always calls YY to analyze the problems for her. Of course, YY is very glad to help LMY. Finally, it is known to us all, YY and LMY become programming lovers.
Could you also solve the shortest-path problem?
 

Input
The input consists of multiple test cases. For each test case, the first line contains three integers N, M and Q, where N is the number of vertices in the given graph, N≤300; M is the number of arcs, M≤100000; and Q is the number of operations, Q ≤100000. All vertices are number as 0, 1, 2, … , N - 1, respectively. Initially all vertices are unmarked. Each of the next M lines describes an arc by three integers (x, y, c): initial vertex (x), terminal vertex (y), and the weight of the arc (c). (c > 0) Then each of the next Q lines describes an operation, where operation “0 x” represents that vertex x is marked, and operation “1 x y” finds the length of shortest-path between x and y only through marked vertices. There is a blank line between two consecutive test cases.
End of input is indicated by a line containing N = M = Q = 0.
 

Output
Start each test case with "Case #:" on a single line, where # is the case number starting from 1.
For operation “0 x”, if vertex x has been marked, output “ERROR! At point x”.
For operation “1 x y”, if vertex x or vertex y isn’t marked, output “ERROR! At path x to y”; if y isn’t reachable from x through marked vertices, output “No such path”; otherwise output the length of the shortest-path. The format is showed as sample output.
There is a blank line between two consecutive test cases.
 

Sample Input

5 10 10 1 2 6335 0 4 5725 3 3 6963 4 0 8146 1 2 9962 1 0 1943 2 1 2392 4 2 154 2 2 7422 1 3 9896 0 1 0 3 0 2 0 4 0 4 0 1 1 3 3 1 1 1 0 3 0 4 0 0 0
 

Sample Output

Case 1: ERROR! At point 4 ERROR! At point 1 0 0 ERROR! At point 3 ERROR! At point 4
 

Source
2010 Asia Regional Tianjin Site —— Online Contest
 


题目大意:

                  给你n个点m条边(单向边)和q次操作,初始时所有点都是没有标记的,有两种操作:

                  1,  0 x:将x标记,如果已近标记过了就输出:见题目输出

                  2, 1 u v :询问从u到v的最短路,并且要求都是被标记过得点,否则输出:见题目输出,

                                  如果到不了就输出:见题目输出,有就输出最短路

题目思路:

                  这题的限制就是最短路要求是标记过得点,所以我们很容易想到的是每次标记一个点

                  然后更新一遍最短路,这样最多更新的次数是n而floyd算法就是每次都跟新经过顶点k的

                  最短路,所以我们可以每次标记点后就更新以该点为顶点的最短路,这样的复杂度为O(n^3+q)


AC代码:


#include
#define min(x,y) (x>=y?y:x)

const int maxn = 3e2+10;
const int inf = 1e8;

class headFloyd{
public:
    int n,m,q,T=0;
    int dis[maxn][maxn],mark[maxn];

    int solve(){
        scanf("%d%d%d",&n,&m,&q);if(!(n+m+q))return -1;
        for(int i=0;i





你可能感兴趣的:(HDU,ACM_最短路径,ACM_思想)